// demoDlg.h : header file
//

#if !defined(AFX_DEMODLG_H__AA2F3B27_347F_11D4_A82A_2CBA02C10000__INCLUDED_)
#define AFX_DEMODLG_H__AA2F3B27_347F_11D4_A82A_2CBA02C10000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog
#define	WAVEHEADERSIZE 44
#define RIFFCORRECTION  8
#define EIGHTBITCORRECTION  127
#define MONO  1
#define STEREO 2

#define HORIZ_DIR 0
#define VERT_DIR  1

#define TIME_TEXT		0
#define BYTE_TEXT		1
#define SAMPLE_TEXT		2


typedef struct tagWHREC{
	char            RIFFHEADER[4];
	long            rifflength;
	char            WAVEName[8];
	long            hlength;
	unsigned short  waveformat;
	unsigned short  channel;
	long            freq;
	long            velocity;
	unsigned short  bytenum;
	unsigned short  bitnum;
	char            DATAHEADER[4];
	long            datalength;
} WHREC;


typedef struct tagDISPLAYSTRUCT{
	CString	FileName;
	CFile	reservedXFile;
	long	filesize;
	long	fileposition;
	long	pagesize;
	float	vertical_magnify;
	float	offset;
	WHREC	WaveHeaderRecord;
} DISPLAYSTRUCT;


typedef struct tagRulerStruct{
	long Dir; //HORIZ_DIR , VERT_DIR
	long texttype;//TIME_TEXT , BYTE_TEXT , SAMPLE_TEXT
	float Base; //minimum difference between two displayed position
	float rangemin;
	float rangemax;
	long min_linedistance;//minimum distance between two displayed line
	long min_textdistance;//minimum distance between the end and begin of two different displayed text
} RulerStructure;


class CDemoDlg : public CDialog
{
// Construction
public:

	BOOL FILE_EXIST;
	DISPLAYSTRUCT myDisplay;
	long DIVISOR;

	void DisplayFFT(DISPLAYSTRUCT *D,BOOL FILE_EXIST);
	void WorkUpSamples(WHREC det,_int16 SA[],long N,float LA[],float RA[]);
	void Ruler(CStatic *R,RulerStructure *RS);
	CDemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDemoDlg)
	enum { IDD = IDD_DEMO_DIALOG };
	CStatic	m_YRulerS2;
	CStatic	m_YRulerS1;
	CStatic	m_YRuler;
	CStatic	m_XRuler;
	CScrollBar	m_horisontalscroll;
	CStatic	m_DisplayFrame;
	BOOL	m_FFT;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonOpen();
	virtual void OnCancel();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnCheckFft();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DEMODLG_H__AA2F3B27_347F_11D4_A82A_2CBA02C10000__INCLUDED_)
